/*****************************************************************************/
/* EHandler.h                                 Copyright Ladislav Zezula 2001 */
/*---------------------------------------------------------------------------*/
/* Header file for the "EHandler.cpp" file.                                  */
/*---------------------------------------------------------------------------*/
/*   Date    Ver   Who  Comment                                              */
/* --------  ----  ---  -----------------------------------------------------*/
/* 21.12.01  1.00  Lad  The first version of DebugInfo.h                     */
/* 21.12.01  1.01  Lad  Added support of Unicode version                     */
/* 03.04.02  1.02  Lad  Renamed to EHandler.h (more exact name)              */
/*****************************************************************************/

#ifndef __DEBUGINFO_H_
#define __DEBUGINFO_H_

#include <tlhelp32.h>
#include "dbghelp.h"

typedef struct _MODULEINFO
{
    LPVOID lpBaseOfDll;
    DWORD SizeOfImage;
    LPVOID EntryPoint;
} MODULEINFO, *LPMODULEINFO;

typedef struct
{
    DWORD ExcCode;                      // Exception code
    const TCHAR * ExcName;              // Exception printable name
} TExceptionName;

// Types for the functions in dbghelp.dll
typedef BOOL  (WINAPI * SYMINITIALIZE)(HANDLE, PSTR, BOOL);
typedef DWORD (WINAPI * SYMSETOPTIONS)(DWORD);
typedef BOOL  (WINAPI * SYMGETSEARCHPATH)(HANDLE, PSTR, DWORD);
typedef BOOL  (WINAPI * SYMSETSEARCHPATH)(HANDLE, PSTR);
typedef DWORD (WINAPI * SYMGETMODULEINFO)(HANDLE, DWORD, PIMAGEHLP_MODULE);
typedef BOOL  (WINAPI * SYMGETLINEFROMADDR)(HANDLE, DWORD, PDWORD, PIMAGEHLP_LINE);
typedef BOOL  (WINAPI * SYMCLEANUP)(HANDLE);

// Types for the PSAPI.dll
//typedef BOOL  (WINAPI * ENUMPROCESSES)(DWORD *, DWORD, DWORD *);
//typedef BOOL  (WINAPI * ENUMMODULES)(HANDLE, HMODULE *, DWORD, LPDWORD);
//typedef BOOL  (WINAPI * GETMODINFO)(HANDLE, HMODULE, MODULEINFO *, DWORD);
//typedef DWORD (WINAPI * GETMODFNEXA)(HANDLE, HMODULE, char *, DWORD);

// Public function in DebugInfo.cpp
int GetSourceNameAndLineNum(DWORD dwAddr, char * szModuleName, char * szFileName, DWORD & dwline);
int ShowExceptionInfo(EXCEPTION_POINTERS * ep, const char * szFunctionName);

#endif // __DEBUGINFO_H_
